import os
from enum import Enum
from load.projects.cloud.env_config import EnvironmentConfig


class EnvType(Enum):
    PROD = 'PROD'
    PREPROD = 'PREPROD'
    LOCAL = 'LOCAL'


HELPER_DEFAULT_CONFIG_PATH = os.path.join('/etc', 'loadtesting', 'cloud.env')
HELPER_CONFIG_PATH_ATTR = 'cloud_helper_config_path'
SERVER_DEFAULT_CONFIG_PATH = os.path.join('/etc', 'loadtesting', 'server.env')
SERVER_CONFIG_PATH_ATTR = 'server_config_path'

PG_DB_PASS_ATTR = 'encrypt_pg_db_pass'
# FIXME delete
DEFAULT_PG_DB_PASS = b"\x00\x00\x00\x01\x00\x00\x00\x14e1036fkplthqau96vife\x00\x00\x00\x10\
\x9f\xbe\xf0d\xdchb\xfa{(\xdd\xfce\x85+\x9f\x00\x00\x00\x0cU=\x8d\xe1\xa8\x8b>f\x8d\xea\x89j\
\xe1\x1fpL\xbe\x82bw\x96M$;\x95\x0b\x81BG6{\x92h\xabjI\x1a\xfdt\xbd\xad\xf3\xf1\xa1\x1a\xc0D"

CH_PASS_ATTR = 'encrypt_ch_db_pass'
DEFAULT_CH_DB_PASS = b'\x00\x00\x00\x01\x00\x00\x00\x14e1036fkplthqau96vife\x00\x00\x00\x109\
\x9a\x97\xbb\xe5\x12yh\x17\xf3\x87\x01\xa95Y!\x00\x00\x00\x0c\x18\xf8\xdc0\x1e8{t@\xeb\xb5\
\xfcB2S\xad\xc8\x11\x15\x8e\xb82\x83C\xc8\xf5K$Z\x0bD\x0f\xbd\xd4\x84\x01SO\xf6\n\x846t[8\xa3N'

DEFAULT_PAGE_SIZE = 100

ENV_CONFIG = EnvironmentConfig()
