#!/usr/bin/env python
from setuptools import setup, find_packages

setup(name='luna',
      version='1.11.9',
      packages=find_packages(),
      include_package_data=True,
      scripts=['volta/manage.py'],
      dependency_links=['https://pypi.yandex-team.ru/simple/django_pgaas/',
                        'https://pypi.yandex-team.ru/repo/default/yandex-passport-vault-client/'],
      install_requires=[
          'requests==2.19.1',
          'django==1.11.20',
          'django-csp',
          'django-tastypie',
          'psycopg2>=2.7.3.2',
          'django_pgaas',
          'retrying',
          'pyyaml>=5.1',
          'uwsgi',
          'pandas==0.23.0',
          'pgcli==2.2.0',
          'cerberus==1.3.1',
          'numpy==1.17.2',
          'yandex-passport-vault-client==1.2.0',
          'parameterized==0.7.1'
      ],
      classifiers=[
          'Environment :: Web Environment',
          'Framework :: Django',
          'Framework :: Django :: 1.11',
      ]
      )
