#!/usr/bin/env python
from setuptools import setup, find_packages

setup(
    name='lunapark',
    version='0.8.14',
    packages=find_packages(),
    scripts=['www/manage.py'],
    dependency_links=[
        'https://pypi.yandex-team.ru/simple',
        'https://pypi.yandex-team.ru/simple/django_pgaas/',
        'https://pypi.yandex-team.ru/repo/default/yandex-passport-vault-client/'
    ],
    install_requires=[
        'beautifulsoup4==4.9.1',
        'blackbox==0.63',
        'cffi==1.14.0',
        'chardet==3.0.4',
        'cryptography==2.9.2',
        'csp==0.1a10',
        'Django==1.11',
        'django-csp==2.0.3',
        'django-pgaas==0.7.0',
        'django-pytest==0.2.0',
        'django-template-common==1.93',
        'django-yauth==4.14',
        'enum34==1.1.10',
        'funcsigs==1.0.2',
        'idna==2.9',
        'ipaddress==1.0.23',
        'mock==3.0.5',
        'numpy==1.14.6',
        'psycopg2==2.8.5',
        'pycparser==2.20',
        'pyOpenSSL==19.1.0',
        'python-dateutil==2.8.1',
        'python-mimeparse==1.6.0',
        'pytz==2020.1',
        'pyuwsgi==2.0.18.post0',
        'PyYAML==5.3.1',
        'requests==2.23.0',
        'retrying==1.3.3',
        'redis==3.5.3',
        'sandbox-library',
        'simplejson==3.17.0',
        'six==1.15.0',
        'startrek-client==2.5',
        'ticket-parser2-py3==2.4.2',
        'tvm2==3.0',
        'urllib3==1.25.9',
        'uWSGI==2.0.18',
        'yandex-passport-vault-client==1.5.2',
        'yandex-tracker-client==1.7',
        'yenv==0.9',
        'ylog==0.49',

    ],
    classifiers=[
          'Environment :: Web Environment',
          'Framework :: Django',
          'Framework :: Django :: 1.11',
      ]

)
